academic_community/notifications/urls.py
"""Urls of the :mod:`notifications` app."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.urls import path
from django.views.decorators.csrf import csrf_exempt

from academic_community.notifications import views

app_name = "notifications"

urlpatterns = [
    path(
        "",
        views.NotificationListView.as_view(),
        name="inbox",
    ),
    path(
        "system/",
        views.SystemNotificationListView.as_view(),
        name="inbox-system",
    ),
    path(
        "user/",
        views.UserNotificationListView.as_view(),
        name="inbox-user",
    ),
    path(
        "chats/",
        views.ChatNotificationListView.as_view(),
        name="inbox-chat",
    ),
    path(
        "archive/",
        views.ArchivedNotificationListView.as_view(),
        name="inbox-archived",
    ),
    path(
        "new/",
        views.CreateOutgoingNotificationView.as_view(),
        name="create-notification",
    ),
    path(
        "settings/",
        views.NotificationSettingsUpdateView.as_view(),
        name="settings",
    ),
    path(
        "settings/system/",
        views.SystemNotificationSettingsUpdateView.as_view(),
        name="settings-system",
    ),
    path(
        "settings/user/",
        views.UserNotificationSettingsUpdateView.as_view(),
        name="settings-user",
    ),
    path(
        "settings/chat/",
        views.ChatNotificationSettingsUpdateView.as_view(),
        name="settings-channels",
    ),
    path(
        "settings/chat/<int:channel_id>/",
        views.ChannelNotificationSettingsUpdateView.as_view(),
        name="settings-channel",
    ),
    path(
        "settings/chat/<int:channel_id>/reset/",
        views.ChannelNotificationSettingsDeleteView.as_view(),
        name="settings-channel-delete",
    ),
    path(
        "webpush/<uuid:uuid>/<int:notification_id>/<token>/",
        csrf_exempt(views.NotificationSubscriptionActionView.as_view()),
        name="subscription-push",
    ),
    path(
        "<int:pk>/",
        views.NotificationDetailView.as_view(),
        name="notification-detail",
    ),
    path(
        "<int:pk>/send/",
        views.SendNotificationView.as_view(),
        name="send-notification",
    ),
]

testproject/urls.py
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: CC0-1.0

"""django-academic-community URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path  # noqa: F401

urlpatterns = [
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path(settings.ADMIN_LOCATION, admin.site.urls),
    path("accounts/", include("django.contrib.auth.urls")),
    path("", include("academic_community.urls")),
]

academic_community/notifications/forms.py
"""Forms for generating notifications."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django import forms
from django.contrib.auth import get_user_model

from academic_community.forms import (
    MultiValueDurationField,
    filtered_select_mutiple_field,
)
from academic_community.notifications import models

User = get_user_model()


class OutgoingNotificationForm(forms.ModelForm):
    """A form to send out a mass email to community members."""

    class Meta:
        model = models.OutgoingNotification

        exclude = ["encryption_key"]

        widgets = {"sender": forms.HiddenInput()}

    recipients = filtered_select_mutiple_field(
        User,
        "Members",
        queryset=User.objects.filter(communitymember__isnull=False),  # type: ignore[misc]
        required=True,
    )

    one_mail_per_user = forms.BooleanField(
        initial=False,
        required=False,
        help_text=(
            "Send one mail per user at maximum. If you send a message to "
            "conveners, for instance, the user will get one mail per sesion "
            "that he or she convenes. If you select this checkbox, the user "
            "will only get one mail for one for the sessions."
        ),
    )


class NotificationSettingsForm(forms.ModelForm):
    """A form to manage notification settings."""

    class Meta:
        model = models.NotificationSettings
        exclude = ["user"]

    class Media:
        js = (
            "https://code.jquery.com/jquery-3.6.0.min.js",  # jquery
            "js/notification_settings.js",
        )

    collation_interval = MultiValueDurationField(
        help_text=(
            "Timespan for sending notifications. 1 Day means, you receive one "
            "email with all the notifications within the last 24 hours (if "
            "there are any)."
        )
    )

academic_community/notifications/views.py
# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from __future__ import annotations

import datetime as dt
import json
import secrets
from typing import TYPE_CHECKING, Any, Dict, List, Optional, Type, Union, cast

import django_select2.forms as s2forms
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import (
    PermissionRequiredMixin as DjangoPermissionRequiredMixin,
)
from django.contrib.auth.mixins import UserPassesTestMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.db.models import Q
from django.forms import Form, ModelChoiceField
from django.forms.models import model_to_dict
from django.http import JsonResponse
from django.shortcuts import get_object_or_404, redirect
from django.template import defaultfilters
from django.templatetags import tz
from django.urls import reverse, reverse_lazy
from django.utils.functional import cached_property
from django.views import generic
from guardian.mixins import LoginRequiredMixin
from guardian.shortcuts import get_objects_for_user

from academic_community.channels.models import Channel
from academic_community.context_processors import get_default_context
from academic_community.events.programme.models import (
    ContributingAuthor,
    Event,
    Session,
)
from academic_community.institutions.models import (
    AcademicMembership,
    Institution,
)
from academic_community.members.models import CommunityMember
from academic_community.mixins import NextMixin
from academic_community.notifications import filters, forms, models
from academic_community.utils import PermissionRequiredMixin

if TYPE_CHECKING:
    from django.contrib.auth.models import User
    from django.db.models import QuerySet

    from academic_community.events.programme.models import Contribution


class NotificationFilterContextMixin:
    """A mixin with a context generator for user notifications."""

    filters: Dict[str, Any]

    request: Any

    def get_mail_context(
        self, member: Optional[Union[User, CommunityMember]] = None
    ) -> List[Dict[str, Any]]:
        attrs = get_default_context(self.request)
        ret = [attrs]
        if hasattr(member, "communitymember"):  # member is a User
            member = member.communitymember  # type: ignore
        if member is not None:
            attrs.update(
                first_name=member.first_name, last_name=member.last_name
            )
            if self.filters:
                data = self.filters
                is_member = isinstance(member, CommunityMember)
                contributions = set()

                event: Event = None  # type: ignore
                session: Optional[Session] = None
                institution_pks = data.get("institutions", [])

                institution_filter_kws = dict(pk__in=institution_pks)

                if data.get("active_institution"):
                    institution_filter_kws["end_date__isnull"] = True
                elif data.get("active_institution") is False:
                    institution_filter_kws["end_date__isnull"] = False

                institutions = Institution.objects.filter(
                    **institution_filter_kws
                )

                if len(institution_filter_kws) > 1:
                    institution_pks = list(
                        institutions.values_list("pk", flat=True)
                    )

                if data.get("session") is not None:
                    if not isinstance(data["session"], Session):
                        session = Session.objects.get(pk=data["session"])
                    else:
                        session = data["session"]
                    event = session.event
                    attrs.update(self._get_session_context(session))
                    attrs.update(self._get_event_context(event))

                elif data.get("event") is not None:
                    if not isinstance(data["event"], Event):
                        event = Event.objects.get(pk=data["event"])
                    else:
                        event = data["event"]
                    attrs.update(self._get_event_context(event))
                elif not institutions:
                    return ret

                institution_contexts = []
                seen = []
                for institution in institutions:
                    if (
                        institution.contact
                        and institution.contact.pk == member.pk
                    ):
                        institution_contexts.append(
                            self.get_institution_context(institution)
                        )
                        seen.append(institution.pk)

                if not data.get("institution_contact"):
                    for membership in member.active_memberships.filter(  # type: ignore[union-attr]
                        Q(organization__institution__pk__in=institution_pks)
                        | Q(
                            organization__department__parent_institution__pk__in=institution_pks
                        )
                        | Q(
                            organization__unit__parent_department__parent_institution__pk__in=institution_pks
                        )
                    ):
                        institution_pk = (
                            membership.organization.organization.parent_institution.pk
                        )
                        if institution_pk not in seen:
                            institution_contexts.append(
                                self.get_membership_context(membership)
                            )
                            seen.append(institution_pk)

                ret = []

                if is_member and data.get("presenter") is not None:
                    member = cast(CommunityMember, member)
                    query = dict(
                        is_presenter=data["presenter"],
                        author__member=member,
                    )
                    if session:
                        query["contribution__session"] = session
                    else:
                        query["contribution__event"] = event
                    for (
                        contributingauthor
                    ) in ContributingAuthor.objects.filter(**query):
                        contributions.add(contributingauthor.contribution)
                if is_member and (
                    data.get("coauthor") is not None
                    or data.get("presentation_type") is not None
                ):
                    member = cast(CommunityMember, member)
                    query = dict(author__member=member)
                    if data.get("presentation_type") is not None:
                        query["contribution__presentation_type"] = data[
                            "presentation_type"
                        ]
                    if session:
                        query["contribution__session"] = session
                    else:
                        query["contribution__event"] = event
                    for (
                        contributingauthor
                    ) in ContributingAuthor.objects.filter(**query):
                        contributions.add(contributingauthor.contribution)
                if contributions:
                    for contribution in contributions:
                        attrs.update(
                            self._get_contribution_context(contribution)
                        )
                        if institution_contexts:
                            for institution_context in institution_contexts:
                                attrs.update(institution_context)
                                ret.append(attrs.copy())
                        else:
                            ret.append(attrs.copy())

                else:
                    if institution_contexts:
                        for institution_context in institution_contexts:
                            attrs.update(institution_context)
                            ret.append(attrs.copy())
                    else:
                        ret.append(attrs)
        return ret

    def get_membership_context(self, membership: AcademicMembership):
        return self.get_institution_context(
            membership.organization.organization.parent_institution
        )

    def get_institution_context(self, institution: Institution):
        """Get the context for institutions."""
        ret = {}

        default_context = get_default_context(self.request)
        root_url = default_context["root_url"]
        ret["institution_name"] = name = institution.name
        ret["institution_abbreviation"] = abbrev = institution.abbreviation
        ret["institution_url"] = url = (
            root_url + institution.get_absolute_url()
        )
        ret["institution_name_url"] = f"<a href='{url}'>{name}</a>"
        ret["institution_abbreviation_url"] = f"<a href='{url}'>{abbrev}</a>"
        contact = institution.contact
        if contact:
            ret["institution_contact_first_name"] = contact.first_name
            ret["institution_contact_last_name"] = contact.last_name
        else:
            ret["institution_contact_first_name"] = ""
            ret["institution_contact_last_name"] = ""
        return ret

    def get_max_one_mail_context(
        self, member: Optional[Union[User, CommunityMember]] = None
    ) -> List[Dict[str, Any]]:
        return self.get_mail_context(member)[:1]

    def _get_contribution_context(
        self, contribution: Contribution
    ) -> Dict[str, str]:
        ret = {}

        default_context = get_default_context(self.request)
        root_url = default_context["root_url"]

        ret["contribution_title"] = title = contribution.title

academic_community/notifications/templates/notifications/components/notification_card.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load humanize %}
{% load bootstrap_helpers %}
{% load django_bootstrap5 %}
{% load notification_helpers %}
{% load bootstrap_helpers %}
{% load community_utils %}
{% load community_utils %}
{% load community_buttons %}
{% load sekizai_tags %}

{% with notification_id=notification.id|stringformat:"s" %}
  {% with elem_id="notification-"|add:notification_id %}
    {% delete_notification_button notification as delete_button %}
    {% select_notification_button notification as select_button %}
    {% details_button notification no_lock=True as notification_details_button %}
    {% buttonize notification.date_created|naturaltime "text-muted" as date %}
    {% collapsible_card notification.subject elem_id accordion_id delete_button add_select_button|ifthen:select_button notification_details_button date button_class=notification.unread|ifthen:"fw-bold" buttons_class="col-md-auto text-secondary px-1 px-md-3" button_row_class="row-cols-2 row-cols-md-4" %}
      <div class="card-text">
        {% if notification.usernotification or notification.chatnotification %}
          {% with sender=notification.usernotification.outgoing_notification.sender|default:notification.chatnotification.comment.user %}
            <p>
              <b>From:</b>
              {% if sender.communitymember %}
                <a href="{{ sender.communitymember.get_absolute_url }}">{{ sender }}</a>
              {% else %}
                {{ sender }}
              {% endif %}
            </p>
          {% endwith %}
        {% endif %}

        {% if notification.encryption_key %}<i>Encrypted message</i>{% else %}{{ notification.body }}{% endif %}
      </div>

      <button onclick="markNotificationAsRead({{ notification.id }}, true)" class="btn btn-primary">
        Mark as unread
      </button>

      {% if notification.chatnotification %}
        <a href="{{ notification.chatnotification.get_absolute_url }}" role="button" class="btn btn-primary">
          View in channel
        </a>
      {% endif %}

      {% if not notification.archived %}
        <button onclick="archiveNotification({{ notification.id }}, true)" class="btn btn-primary">
          Archive
        </button>
      {% endif %}

      {% if not user.communitymember or user.communitymember.email.is_verified %}
        <form class="d-inline-block" action="{% url 'notifications:send-notification' notification.id %}" method="post" id="sendNotification{{ notification.id }}">
          {% csrf_token %}
          {% bootstrap_button "Send as mail" button_type="submit" %}
        </form>
      {% endif %}

      <footer id="sendNotification{{ notification.id }}-footer" class="text-muted mt-2">
        {% if notification.date_sent %}
          Sent via mail: {{ notification.date_sent|naturaltime }}
        {% endif %}
      </footer>
    {% endcollapsible_card %}
  {% endwith %}
{% endwith %}

{% addtoblock "js" %}
<script>

  function deleteNotification(id) {
    $.ajax({
      url: `{% url 'rest:notification-list' %}${id}/`,
      type: 'DELETE',
      data: {},
      headers:{'X-CSRFTOKEN':$('input[name="csrfmiddlewaretoken"]').val()},
      success: function (data) {
        {% if notification.get_absolute_url|same_url:request.path %}
          {% url 'notifications:inbox' as inbox_url %}
          document.location = "{{ next_url|default:inbox_url }}"
        {% else %}
          document.location.reload();
        {% endif %}
      }
    });
  }

  function markNotificationAsRead(id, unread) {
    $.ajax({
      url: `{% url 'rest:notification-list' %}${id}/`,
      type: 'PATCH',
      data: {unread: unread},
      headers:{'X-CSRFTOKEN':$('input[name="csrfmiddlewaretoken"]').val()},
      success: function (data) {
        if (unread) {
          $(`#notification-${id}-content`).collapse("hide");
          $(`#notification-${id}-control`).addClass("fw-bold");
        }
      }
    });
  }

function archiveNotification(id) {
  $.ajax({
    url: `{% url 'rest:notification-list' %}${id}/`,
    type: 'PATCH',
    data: {archived: true},
    headers:{'X-CSRFTOKEN':$('input[name="csrfmiddlewaretoken"]').val()},
    success: function (data) {
      document.location.reload();
    }
  });
}

  $(document).ready(function () {
    $("div[id^='notification-']")
      .filter(function() {
        return this.id.match(/notification-\d+$/)
      })
      .on('show.bs.collapse', function () {
        markNotificationAsRead(this.id.match(/\d+/)[0], false, false);
        $(`#${this.id}-control`).removeClass("fw-bold");
    })

    $("form[id^='sendNotification']").submit(function(e) {
      e.preventDefault();
      var elemId = this.id;
      $.ajax({
          url: this.action,
          type: this.method,
          data: $(this).serialize(),
          success:function(){
              // Whatever you want to do after the form is successfully submitted
              $(`#${elemId}-footer`).html("Sent via mail: now");
              $("#systemMessages").append(`
                <div class="alert alert-success alert-dismissible" role="alert">
                  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="close"></button>
                  Message successfully sent.
                </div>
              `);
          }
      });
    })
  })

</script>
{% endaddtoblock %}

academic_community/notifications/templates/notifications/components/notification_mail_body.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% if notification.encryption_key %}<i>Encrypted message</i>{% else %}{{ notification.body }}{% endif %}
{% spaceless %}
{% if notification.usernotification %}
{% with sender=notification.usernotification.outgoing_notification.sender %}
  <p>
    <b>From:</b>
    {% if sender.communitymember %}
      <a href="{{ sender.communitymember.get_absolute_url }}">{{ sender }}</a>
    {% else %}
      {{ sender }}
    {% endif %}
  </p>
{% endwith %}
{% endif %}
{% endspaceless %}